# Source Generated with Decompyle++
# File: in.pyc (Python 1.5)

import whrandom
randrange
sin

def makeseed(a = None):
    '''Turn a hashable value into three seed values for whrandom.seed().

\tNone or no argument returns (0, 0, 0), to seed from current time.

\t'''
    if a is None:
        return (0, 0, 0)
    
    a = hash(a)
    (a, x) = divmod(a, 256)
    (a, y) = divmod(a, 256)
    (a, z) = divmod(a, 256)
    if not (x + a) % 256:
        pass
    x = 1
    if not (y + a) % 256:
        pass
    y = 1
    if not (z + a) % 256:
        pass
    z = 1
    return (x, y, z)


def seed(a = None):
    '''Seed the default generator from any hashable value.

\tNone or no argument returns (0, 0, 0) to seed from current time.

\t'''
    (x, y, z) = makeseed(a)
    whrandom.seed(x, y, z)


class generator(whrandom.whrandom):
    '''Random generator class.'''
    
    def __init__(self, a = None):
        '''Constructor.  Seed from current time or hashable value.'''
        self.seed(a)

    
    def seed(self, a = None):
        '''Seed the generator from current time or hashable value.'''
        (x, y, z) = makeseed(a)
        whrandom.whrandom.seed(self, x, y, z)



def new_generator(a = None):
    '''Return a new random generator instance.'''
    return generator(a)


def verify(name, expected):
    computed = eval(name)
    if abs(computed - expected) > 1e-07:
        raise ValueError, 'computed value for %s deviates too much (computed %g, expected %g)' % (name, computed, expected)
    

NV_MAGICCONST = 4 * exp(-0.5) / sqrt(2.0)
verify('NV_MAGICCONST', 1.71552776992)

def normalvariate(mu, sigma):
    while 1:
        u1 = random()
        u2 = random()
        z = NV_MAGICCONST * (u1 - 0.5) / u2
        zz = z * z / 4.0
        if zz <= -log(u2):
            break
        
    return mu + z * sigma


def lognormvariate(mu, sigma):
    return exp(normalvariate(mu, sigma))


def cunifvariate(mean, arc):
    return (mean + arc * (random() - 0.5)) % pi


def expovariate(lambd):
    u = random()
    while u <= 1e-07:
        u = random()
    return -log(u) / lambd

TWOPI = 2.0 * pi
verify('TWOPI', 6.28318530718)

def vonmisesvariate(mu, kappa):
    if kappa <= 1e-06:
        return TWOPI * random()
    
    a = 1.0 + sqrt(1.0 + 4.0 * kappa * kappa)
    b = (a - sqrt(2.0 * a)) / (2.0 * kappa)
    r = (1.0 + b * b) / (2.0 * b)
    while 1:
        u1 = random()
        z = cos(pi * u1)
        f = (1.0 + r * z) / (r + z)
        c = kappa * (r - f)
        u2 = random()
        if u2 >= c * (2.0 - c):
            pass
        if not (u2 > c * exp(1.0 - c)):
            break
        
    u3 = random()
    if u3 > 0.5:
        theta = mu % TWOPI + acos(f)
    else:
        theta = mu % TWOPI - acos(f)
    return theta

LOG4 = log(4.0)
verify('LOG4', 1.38629436112)

def gammavariate(alpha, beta):
    ainv = sqrt(2.0 * alpha - 1.0)
    return beta * stdgamma(alpha, ainv, alpha - LOG4, alpha + ainv)

SG_MAGICCONST = 1.0 + log(4.5)
verify('SG_MAGICCONST', 2.50407739678)

def stdgamma(alpha, ainv, bbb, ccc):
    if alpha <= 0.0:
        raise ValueError, 'stdgamma: alpha must be > 0.0'
    
    if alpha > 1.0:
        while 1:
            u1 = random()
            u2 = random()
            v = log(u1 / (1.0 - u1)) / ainv
            x = alpha * exp(v)
            z = u1 * u1 * u2
            r = bbb + ccc * v - x
            if r + SG_MAGICCONST - 4.5 * z >= 0.0 or r >= log(z):
                return x
            
    elif alpha == 1.0:
        u = random()
        while u <= 1e-07:
            u = random()
        return -log(u)
    else:
        while 1:
            u = random()
            b = (e + alpha) / e
            p = b * u
            if p <= 1.0:
                x = pow(p, 1.0 / alpha)
            else:
                x = -log((b - p) / alpha)
            u1 = random()
            if p <= 1.0 and u1 > exp(-x) and p > 1:
                pass
            if not (u1 > pow(x, alpha - 1.0)):
                break
            
        return x

gauss_next = None

def gauss(mu, sigma):
    global gauss_next, gauss_next
    z = gauss_next
    gauss_next = None
    if z is None:
        x2pi = random() * TWOPI
        g2rad = sqrt(-2.0 * log(1.0 - random()))
        z = cos(x2pi) * g2rad
        gauss_next = sin(x2pi) * g2rad
    
    return mu + z * sigma


def betavariate(alpha, beta):
    y = expovariate(alpha)
    z = expovariate(1.0 / beta)
    return z / (y + z)


def paretovariate(alpha):
    u = random()
    return 1.0 / pow(u, 1.0 / alpha)


def weibullvariate(alpha, beta):
    u = random()
    return alpha * pow(-log(u), 1.0 / beta)


def test(N = 200):
    print 'TWOPI         =', TWOPI
    print 'LOG4          =', LOG4
    print 'NV_MAGICCONST =', NV_MAGICCONST
    print 'SG_MAGICCONST =', SG_MAGICCONST
    test_generator(N, 'random()')
    test_generator(N, 'normalvariate(0.0, 1.0)')
    test_generator(N, 'lognormvariate(0.0, 1.0)')
    test_generator(N, 'cunifvariate(0.0, 1.0)')
    test_generator(N, 'expovariate(1.0)')
    test_generator(N, 'vonmisesvariate(0.0, 1.0)')
    test_generator(N, 'gammavariate(0.5, 1.0)')
    test_generator(N, 'gammavariate(0.9, 1.0)')
    test_generator(N, 'gammavariate(1.0, 1.0)')
    test_generator(N, 'gammavariate(2.0, 1.0)')
    test_generator(N, 'gammavariate(20.0, 1.0)')
    test_generator(N, 'gammavariate(200.0, 1.0)')
    test_generator(N, 'gauss(0.0, 1.0)')
    test_generator(N, 'betavariate(3.0, 3.0)')
    test_generator(N, 'paretovariate(1.0)')
    test_generator(N, 'weibullvariate(1.0, 1.0)')


def test_generator(n, funccall):
    import time
    print n, 'times', funccall
    code = compile(funccall, funccall, 'eval')
    sum = 0.0
    sqsum = 0.0
    smallest = 10000000000.0
    largest = -10000000000.0
    t0 = time.time()
    for i in range(n):
        x = eval(code)
        sum = sum + x
        sqsum = sqsum + x * x
        smallest = min(x, smallest)
        largest = max(x, largest)
    
    t1 = time.time()
    print round(t1 - t0, 3), 'sec,',
    avg = sum / n
    stddev = sqrt(sqsum / n - avg * avg)
    print 'avg %g, stddev %g, min %g, max %g' % (avg, stddev, smallest, largest)

